Subject: Re: [PATCH] net: kcm: fix memory leak in kcm_sendmsg

From: Pavel Skripkin <[email-masked]>
Date: Fri, 4 Jun 2021 14:38:50 +0300

On Thu, 3 Jun 2021 15:32:03 -0700
Cong Wang <[email-masked]> wrote:

> On Wed, Jun 2, 2021 at 12:29 PM Pavel Skripkin <[email-masked]>
> wrote:
> >
> > Syzbot reported memory leak in kcm_sendmsg()[1].
> > The problem was in non-freed frag_list in case of error.
> >
> > In the while loop:
> >
> >         if (head == skb)
> >                 skb_shinfo(head)->frag_list = tskb;
> >         else
> >                 skb->next = tskb;
> >
> > frag_list filled with skbs, but nothing was freeing them.
> 
> What do you mean by "nothing was freeing them"?
> 
> I am sure kfree_skb() will free those in frag_list:
> 
>  654 static void skb_release_data(struct sk_buff *skb)
>  655 {
>  656         struct skb_shared_info *shinfo = skb_shinfo(skb);
>  657         int i;
> ...
>  669         if (shinfo->frag_list)
>  670                 kfree_skb_list(shinfo->frag_list);
> 
> 

Indeed. I didn't know about that. Im sorry.

> >
> > backtrace:
> >   [<0000000094c02615>] __alloc_skb+0x5e/0x250 net/core/skbuff.c:198
> >   [<00000000e5386cbd>] alloc_skb include/linux/skbuff.h:1083
> > [inline] [<00000000e5386cbd>] kcm_sendmsg+0x3b6/0xa50
> > net/kcm/kcmsock.c:967 [1] [<00000000f1613a8a>] sock_sendmsg_nosec
> > net/socket.c:652 [inline] [<00000000f1613a8a>]
> > sock_sendmsg+0x4c/0x60 net/socket.c:672
> >
> > Reported-and-tested-by:
> > [email-masked] Fixes:
> > ab7ac4eb9832 ("kcm: Kernel Connection Multiplexor module") Cc:
> > [email-masked] Signed-off-by: Pavel Skripkin
> > <[email-masked]> ---
> >  net/kcm/kcmsock.c | 5 +++++
> >  1 file changed, 5 insertions(+)
> >
> > diff --git a/net/kcm/kcmsock.c b/net/kcm/kcmsock.c
> > index 6201965bd822..1c572c8daced 100644
> > --- a/net/kcm/kcmsock.c
> > +++ b/net/kcm/kcmsock.c
> > @@ -1066,6 +1066,11 @@ static int kcm_sendmsg(struct socket *sock,
> > struct msghdr *msg, size_t len) goto partial_message;
> >         }
> >
> > +       if (skb_has_frag_list(head)) {
> > +               kfree_skb_list(skb_shinfo(head)->frag_list);
> > +               skb_shinfo(head)->frag_list = NULL;
> > +       }
> > +
> >         if (head != kcm->seq_skb)
> >                 kfree_skb(head);
> 
> This exact kfree_skb() should free those in frag_list. If the above
> if condition does not meet for some reason, then fix that condition?
> 
> Thanks.

I will debug this today later. I think, this commit should be reverted,
because it's broken. Or I can send next patch on top of this. What do
you think of that, David? 

With regards,
Pavel Skripkin